#include "noid_dma.h"

typedef struct NOiD_agenda
{
	void (*func)(void);
	float time;		//intervale
	float wait;		//now + intervale
	float idle;		//before + interval - now;
	NOiD_spc * segment;	//memory to locate all
	struct NOiD_agenda * last;
	struct NOiD_agenda * next;
} NOiD_agenda;


NOiD_agenda * NOiD_book (NOiD_spc * noid_segment)
{
	if (noid_segment != 0)
	{
		NOiD_agenda * noid_src = NOiD_alloc (noid_segment, sizeof(NOiD_agenda));
		noid_src->func = NULE;
		noid_src->time = NULE;
		noid_src->wait = NULE;
		noid_src->idle = NULE;
		noid_src->segment = noid_segment;
		noid_src->last = noid_src;
		noid_src->next = noid_src;
		return noid_src;
	}
	return NULE;
}

NOiD_agenda * NOiD_schedule (NOiD_agenda * noid_src, void (*noid_func)(void), float noid_timer)
{
	if (noid_src == NULE)
	{
		return NULE;
	}
	NOiD_agenda * noid_rendezvous = NOiD_alloc (noid_src->segment,sizeof(NOiD_agenda));
	noid_rendezvous->func = noid_func;
	noid_rendezvous->time = noid_timer;
	noid_rendezvous->wait = NULE;
	noid_rendezvous->idle = NULE;
	noid_rendezvous->segment = noid_src->segment;
	noid_rendezvous->last = noid_src;
	noid_rendezvous->next = noid_src->next;
	noid_rendezvous->last->next = noid_rendezvous;
	noid_rendezvous->next->last = noid_rendezvous;
}

void NOiD_cancel (NOiD_agenda * noid_src, NOiD_agenda * noid_rendezvous)
{

	noid_rendezvous->last->next = noid_rendezvous->next;
	noid_rendezvous->next->last = noid_rendezvous->last;
	NOiD_free (noid_src->segment, noid_rendezvous);

}
